//-----------------------------------------------------------------------------
// jondahli
//
// JonDahliAp.java
//
// Custom application class to maintain state across activities
//
// (c) 2011 Brandon Valosek
//-----------------------------------------------------------------------------

package com.bvalosek.jondahli;

// my stuff
import com.bvalosek.jondahli.core.Dahli;
import com.bvalosek.jondahli.core.ConvoEntry;

// imports
import android.app.Application;
import java.util.List;
import java.util.ArrayList;
import java.io.InputStream;
import android.util.Log;

/* class used to maintain state across all activities */
public class JonDahliApp extends Application {

   // the Dahli engine
   private Dahli mDahli = new Dahli ();

   // don't want to load the defaults twice
   private boolean isDefaultsLoaded = false;

   // return ref to the convo we're keeping
   public List<ConvoEntry>  getThread () {
   	return mDahli.getThread();
   }

   /** get the app's Dahli objects */
   public Dahli getDahli () {
   	return mDahli;
   }
   
   /** load the defaults into jon */
   public boolean loadDefaults () {
      if (isDefaultsLoaded) {
      	return true;
      }

      // else..
      isDefaultsLoaded = true;

      InputStream is = null;

      // load from file
      try {
         is = getAssets().open("default.txt");

         // call dahli:
         mDahli.loadConvoFromStream(is);
         is.close (); 

      } catch (Exception e) {
         Log.e("jond", "problem " + e);
         return false;
      }
     
      // made it
      return true;

   }
}
