//-----------------------------------------------------------------------------
// jondahli
//
// Word.java
//
// Atomic word object
//
// (c) 2011 Brandon Valosek
//-----------------------------------------------------------------------------

package com.bvalosek.jondahli.core;

// imports
import java.util.List;
import java.util.ArrayList;
import android.util.Log;

/** container class with all info about a single word */
public class Word {

   // namesake
   private String    mWord = "";

   // links to phrases containing this word
   private List<Phrase> mUsedIn = new ArrayList<Phrase> ();

   /** take the actual word to ctor */
   public Word (String w) {
   	mWord = w;
   }

   /** string version of the word */
   public String getText() {
   	return mWord;
   }

   /** spit out text */
   public String toString () {
      return getText();
   }

   /** compare */
   @Override public boolean equals (Object obj) {
      if (this == obj)
         return true;
      if (obj == null)
         return false;
      if (getClass() != obj.getClass())
         return false;

      // compare the word members
      Word w = (Word)obj;
      if (w.getText().equals (mWord) ) {
         return true;
      }

   	// didn't match
   	return false;
   }

   /** add a phrase that this word is used in */
   public int addPhrase (Phrase p) {
   	mUsedIn.add (p);
      return mUsedIn.size ();
   }

   /** get the phrases this word is used in */
   public List<Phrase> getPhrases () {
   	return mUsedIn;
   }
}
